/*! \mainpage Task Description
 *
 * Implement the functions below.
 *
 * Unless stated otherwise, all the functions are expected to return nothing.
 *
 * REQUIREMENT: you must use smart pointers in this task.
 *
 * @file
 */

#include <stdexcept>
#include "solution.hpp"
#include <stack>

/**
 * Construct the tree from string representation.
 * Input ab@ means that the root node has two child leafs, a on the left and b on the right.
 * Input abc@@ means that the left child of the root node is leaf a, the right child is a subtree with left child leaf b
 * and right child leaf c.
 * @param s a formatted string representation of a binary tree.
 */
MyTree::MyTree(const std::string &s) {}

/**
 * Function that serializes a given tree by pushing its string representation into an output stream.
 * @param os an instance of an output stream.
 * @param tree an instance of a binary tree.
 * @return an instance of an output stream.
 */
std::ostream &operator<<(std::ostream &os, const MyTree &tree) {
    return os;
}
